nodeColour = {40, 168, 107}
edgeColour = {255, 255, 255}
keyColour = {200, 34, 200}

red = {255, 0, 45}
yellow = {255, 244, 25}
blue = {9, 129, 178}
white = {255, 255, 255, 0}

pink = {253, 121, 145}

love.graphics.setBackgroundColor(86, 170, 204)

love.graphics.setLineStyle("smooth")
lineWidth = 4
love.graphics.setLineWidth(lineWidth * (w/1920))

nodeSize = 6
locked = false

love.mouse.setRelativeMode(not locked)

draw3D = true
drawNodes = false
drawEdges = true
drawFaces = true
drawTexture = false

debug = false
numDraws = 0 -- Debug Info (line 150, 3D.lua)

drawTable = {}
objects = {}
realPos = {}

sin = math.sin
cos = math.cos
isDown = love.keyboard.isDown

function drawEverything()
	if drawFaces then
		for i,v in ipairs(objects) do
			for k,j in ipairs(v.faces) do
				local points = {}
				local canDraw = true

				local edges = {
					[1] = true, -- Top
					[2] = true, -- Right
					[3] = true, -- Bottom
					[4] = true, -- Left
				}
				local coMod = {
					x = 0,
					y = 0,
					z = 0,
				}

				if j.t == "top" then coMod.y = 1 end
				if j.t == "bottom" then coMod.y = -1 end
				if j.t == "left" then coMod.x = 1 end
				if j.t == "right" then coMod.x = -1 end
				if j.t == "forward" then coMod.z = 1 end
				if j.t == "backwards" then coMod.z = -1 end

				if j.t == "top" or j.t == "bottom" then
					if checkMap({x=v.coOrd.x, y=v.coOrd.y, z=v.coOrd.z - 1}) then edges[1] = false end
					if checkMap({x=v.coOrd.x, y=v.coOrd.y, z=v.coOrd.z + 1}) then edges[3] = false end
					if checkMap({x=v.coOrd.x - 1, y=v.coOrd.y, z=v.coOrd.z}) then edges[2] = false end
					if checkMap({x=v.coOrd.x + 1, y=v.coOrd.y, z=v.coOrd.z}) then edges[4] = false end
				end
				if j.t == "left" or j.t == "right" then
					if checkMap({x=v.coOrd.x, y=v.coOrd.y + 1, z=v.coOrd.z}) then edges[1] = false end
					if checkMap({x=v.coOrd.x, y=v.coOrd.y - 1, z=v.coOrd.z}) then edges[3] = false end
					if checkMap({x=v.coOrd.x, y=v.coOrd.y, z=v.coOrd.z + 1}) then edges[2] = false end
					if checkMap({x=v.coOrd.x, y=v.coOrd.y, z=v.coOrd.z - 1}) then edges[4] = false end
				end
				if j.t == "forward" or j.t == "backwards" then
					if checkMap({x=v.coOrd.x, y=v.coOrd.y + 1, z=v.coOrd.z}) then edges[1] = false end
					if checkMap({x=v.coOrd.x, y=v.coOrd.y - 1, z=v.coOrd.z}) then edges[3] = false end
					if checkMap({x=v.coOrd.x - 1, y=v.coOrd.y, z=v.coOrd.z}) then edges[2] = false end
					if checkMap({x=v.coOrd.x + 1, y=v.coOrd.y, z=v.coOrd.z}) then edges[4] = false end
				end

				if v.coOrd.x + coMod.x >= 1 and v.coOrd.x + coMod.x <= mapWidth and
					v.coOrd.y + coMod.y >= 1 and v.coOrd.y + coMod.y <= mapHeight and
					v.coOrd.z + coMod.z >= 1 and v.coOrd.z + coMod.z <= mapLength then
					if map[v.coOrd.x + coMod.x][v.coOrd.y + coMod.y][v.coOrd.z + coMod.z] == 1 then
						for q=1, #j.vert do
							local n = j.vert[q]
							local node, ccanDraw = point3Dto2D(v.nodes[n])
							if ccanDraw == false then canDraw = false end

							points[#points + 1] = node[1]
							points[#points + 1] = node[2]
						end
						
						-- local node, ccanDraw, w1 = point3Dto2D(v.nodes[j.vert[1]])
						-- local node2, ccanDraw2, w2 = point3Dto2D(v.nodes[j.vert[2]])

						-- points[#points + 1] = node[1]
						-- points[#points + 1] = node[2]

						-- -- Clipping Plane
						-- if (ccanDraw and not ccanDraw2) or (not ccanDraw and ccanDraw2) then
						-- 	local n = w1 / (w1 - w2)
						-- 	vc = {
						-- 		(n * v.nodes[j.vert[1]][1]) + ((1-n) * v.nodes[j.vert[2]][1]),
						-- 		(n * v.nodes[j.vert[1]][2]) + ((1-n) * v.nodes[j.vert[2]][2]),
						-- 		(n * v.nodes[j.vert[1]][3]) + ((1-n) * v.nodes[j.vert[2]][3])
						-- 	}

						-- 	local node3, ccanDraw3, w3 = point3Dto2D(vd)
						-- 	points[#points + 1] = node3[1]
						-- 	points[#points + 1] = node3[1]
						-- end

			            local middle = getMiddleOfFace(i, k)

			            -- Do not draw things outside of screen
			            if canDraw then 
							table.insert(drawTable, {dist = math.dist3D(middle[1], middle[2], middle[3], c[1], c[2], c[3]), id = i, c = j.c, points = points, edges = edges})
						end
					end
				else
					for q=1, #j.vert do
						local n = j.vert[q]
						local node, ccanDraw = point3Dto2D(v.nodes[n])
						if ccanDraw == false then canDraw = false end

						points[#points + 1] = node[1]
						points[#points + 1] = node[2]
					end

		            local middle = getMiddleOfFace(i, k)

		            -- Do not draw things outside of screen
		            if canDraw then 
						table.insert(drawTable, {dist = math.dist3D(middle[1], middle[2], middle[3], c[1], c[2], c[3]), id = i, c = j.c, points = points, edges = edges})
					end
				end
			end
		end
	end
	
	-- Sort and Draw --------------------------
	table.sort(drawTable, rsort)
	local numTable = {}

	for i,v in ipairs(drawTable) do
		if not numTable[v.id] then numTable[v.id] = 0 end
		numTable[v.id] = numTable[v.id] + 1

		if numTable[v.id] >= 4 then
			table.remove(drawTable, i)
		end
    end

    table.sort(drawTable, sort)
	for i,v in ipairs(drawTable) do
		if not drawTexture then
			love.graphics.setColor(v.c)
			love.graphics.polygon("fill", v.points)
		else
			if v.c == red then
				pers.quad(top1, {v.points[1], v.points[2]}, {v.points[3], v.points[4]}, {v.points[5], v.points[6]}, {v.points[7], v.points[8]})
			elseif v.c == yellow then
				pers.quad(side1, {v.points[1], v.points[2]}, {v.points[3], v.points[4]}, {v.points[5], v.points[6]}, {v.points[7], v.points[8]})
			elseif v.c == blue then
				pers.quad(top2, {v.points[1], v.points[2]}, {v.points[3], v.points[4]}, {v.points[5], v.points[6]}, {v.points[7], v.points[8]})
			elseif v.c == pink then
				pers.quad(side2, {v.points[1], v.points[2]}, {v.points[3], v.points[4]}, {v.points[5], v.points[6]}, {v.points[7], v.points[8]})
			end
		end

		if drawEdges then
			love.graphics.setColor(edgeColour)

			if v.edges[1] then love.graphics.line(v.points[1], v.points[2], v.points[3], v.points[4]) end
			if v.edges[2] then love.graphics.line(v.points[3], v.points[4], v.points[5], v.points[6]) end
			if v.edges[3] then love.graphics.line(v.points[5], v.points[6], v.points[7], v.points[8]) end
			if v.edges[4] then love.graphics.line(v.points[7], v.points[8], v.points[1], v.points[2]) end
		end
    end

    numDraws = #drawTable
	drawTable = {}
	-------------------------------------------
	
	if drawNodes then
		for i,v in ipairs(objects) do
			for k,j in ipairs(v.nodes) do
				love.graphics.setColor(nodeColour)
					
				if j.idd == -1 then
					love.graphics.setColor(keyColour)
				end
					
				local node, canDraw = point3Dto2D(j)

				if canDraw then
					love.graphics.circle("fill", node[1], node[2], nodeSize, nodeSize)
					love.graphics.setColor(255, 255, 255)
					love.graphics.print(tostring(k), node[1], node[2])
				end
			end
		end	
	end
end

function checkMap(coOrd, number)
	number = number or 2

	if coOrd.x >= 1 and coOrd.x <= mapWidth and
		coOrd.y >= 1 and coOrd.y <= mapHeight and
		coOrd.z >= 1 and coOrd.z <= mapLength then
			if map[coOrd.x][coOrd.y][coOrd.z] == number then
				return true
			end
	end
	return false
end

function sort(a, b) return a.dist > b.dist end
function rsort(a, b) return a.dist < b.dist end

function math.dist3D(x1,y1,z1, x2,y2,z2) return ((x2-x1)^2+(y2-y1)^2+(z2-z1)^2)^0.5 end
function math.dist2D(x1,y1, x2,y2) return ((x2-x1)^2+(y2-y1)^2)^0.5 end