function newNode(x, y, z, id, idd)
	idd = idd or 0

	table.insert(objects[id].nodes, {
		[1] = x,
		[2] = y, 
		[3] = z,
		idd = idd,
	})
end

function removeNode(id, i)
	table.remove(objects[id].nodes, i)
end

function newFace(vertices, id, color, type)
	table.insert(objects[id].faces, {vert = vertices, c = color, t = type})
end

function getMiddleOfFace(id, i)
	local v = objects[id].faces[i].vert
	local nodes = objects[id].nodes
	
	return {(nodes[v[1]][1] + nodes[v[3]][1]) / 2, (nodes[v[1]][2] + nodes[v[3]][2]) / 2, (nodes[v[1]][3] + nodes[v[3]][3]) / 2}
end

function getInitNode(id)
	return objects[id].nodes[1]
end

-- posY is the height
function createCube(posX, poxY, posZ, w, l, h, coOrd, color)
	notBuilding = notBuilding or false
	color = color or {red, yellow, blue}
	local id = #objects + 1
	objects[id] = {
		nodes = {},
		faces = {},
		coOrd = coOrd,
	}

	w = w / 2
	l = l / 2

	newNode( posX, 	   poxY, 	 posZ, id, -1)
	newNode( posX + w, poxY, 	 posZ - l, id)
	newNode( posX - w, poxY + h, posZ - l, id)
	newNode( posX + w, poxY + h, posZ - l, id)
	newNode( posX - w, poxY, 	 posZ - l, id)
	newNode( posX - w, poxY + h, posZ + l, id)
	newNode( posX + w, poxY, 	 posZ + l, id)
	newNode( posX - w, poxY, 	 posZ + l, id)
	newNode( posX + w, poxY + h, posZ + l, id)

	newFace({4, 3, 6, 9}, id, color[1], "top")
	newFace({2, 5, 8, 7}, id, color[1], "bottom")
	newFace({9, 6, 8, 7}, id, color[2], "forward")
	newFace({4, 3, 5, 2}, id, color[2], "backwards")
	newFace({3, 6, 8, 5}, id, color[3], "right")
	newFace({4, 9, 7, 2}, id, color[3], "left")

	return id
end