love.graphics.setDefaultFilter("nearest", "nearest")
w, h = love.graphics.getDimensions()

require("cde/3D")
require("cde/misc")
require("cde/misc3D")

require("cde/tableSer")
pers = require("cde/pers")

top1 = love.graphics.newImage("top.png")
side1 = love.graphics.newImage("side.png")
top2 = love.graphics.newImage("top2.png")
side2 = love.graphics.newImage("side2.png")

--math.randomseed(os.time())

map = {}

local colorTable = {red,yellow,blue,pink}
local globalDT = 0
mapWidth, mapLength, mapHeight = 10, 10, 20

for x = 1, mapWidth do
	map[x] = {}
	for y = 1, mapHeight do
		map[x][y] = {}
		for z = 1, mapLength do
			local number = 2
			if math.random() < 0.8 then number = 1 end
			if y == 1 or y == mapHeight then number = 2 end

			local ccc = math.random(1,2)
			if ccc == 2 then ccc = 3 end

			if number == 2 then
				createCube(32 * (x-1), 32 * (y-1), 32 * (z-1), 32, 32, 32, {x=x, y=y, z=z}, {colorTable[ccc],colorTable[ccc+1],colorTable[ccc+1]})
			end

			map[x][y][z] = number
		end
	end
end
--createCube(0, 0, 0, 32, 32, 32)

c = {100, 700, 0} -- Camera Pos
o = {math.rad(-90), 0, 0} -- Orientation
e = {-love.graphics.getWidth() / 2, -love.graphics.getHeight() / 2, love.graphics.getWidth() / 2} -- FOV?

function love.draw()
	--love.graphics.setShader(myShader)
    drawEverything()
    --love.graphics.setShader()

	love.graphics.setColor(255, 255, 255)
	if debug then
		love.graphics.print(string.format("FPS: %1.f\nPos:  %1.f %1.f %1.f\nNumber of Faces Drawn: %1.f", love.timer.getFPS(), c[1], c[2], c[3], numDraws))
	end
end

function love.update(dt)
	if isDown("d") then 
		c[1] = c[1] - 100 * dt * cos(o[2])
		c[3] = c[3] + 100 * dt * sin(o[2])
	end
	
	if isDown("a") then
	 	c[1] = c[1] + 100 * dt * cos(o[2])
	  	c[3] = c[3] - 100 * dt * sin(o[2])
	end
	
	if isDown("e") then c[2] = c[2] - 100 * dt end
	if isDown("q") then c[2] = c[2] + 100 * dt end
	
	if isDown("w") then
		c[3] = c[3] - 100 * dt * cos(o[2]) * cos(o[1])
		c[1] = c[1] - 100 * dt * sin(o[2]) * cos(o[1])
		c[2] = c[2] + 100 * dt * sin(o[1])			
	end
	
	if isDown("s") then 
		c[3] = c[3] + 100 * dt * cos(o[2]) * cos(o[1])
		c[1] = c[1] + 100 * dt * sin(o[2]) * cos(o[1])
		c[2] = c[2] - 100 * dt * sin(o[1])		
	end

	globalDT = dt
end

function love.mousemoved(x, y, dx, dy)
	-- Mouse Look
	if not locked then
		local dampen = 10
		
		o[2] = o[2] + (dx/dampen) * globalDT
		o[1] = o[1] - (dy/dampen) * globalDT
		
		love.mouse.setPosition(w/2, h/2)
	end
end

function love.keypressed(key)
	if key == "escape" then love.event.quit() end

	if key == "tab" then
		locked = not locked
		love.mouse.setRelativeMode(not locked)
	end

	if key == "`" then
		debug = not debug
		--drawNodes = not drawNodes
	end

	if key == "b" then
		timer = 10
	end
end

function love.resize(width, height)
	w, h = width, height
	e = {-w / 2, -h / 2, w / 2}
	love.graphics.setLineWidth(lineWidth * (w/1920))
	pers.resize(h)
end